//+------------------------------------------------------------------+
//|                                                      Sputnik.mq4 |
//|                                                                  |
//|                                       Copyright 2006 Nick Barker |
//|                                         http://www.forex-tsd.com |
//|                                       http://www.tradingintl.com |
//|                                                                  | 
//|                                                                  |
//+------------------------------------------------------------------+

#property copyright "Copyright 2006, Nick Barker, Apex Group Investments, LLC"
#property link      "http://www.tradingintl.com"
#include <stdlib.mqh>
#include <WinUser32.mqh>


///////////////////////////////////////////////////Variables//////////////////////////////
extern string  EAname="SpoutNik";
extern int     ID_BASE=300000; // Change this number if running more than one EA on the same pair

extern int     MaxTrades=1;          //maximum number of trades open at a time
extern double  lots=1.0; // This number will not matter if using Money Management 
extern int     stoploss=0,takeprofit=0;
//extern bool    MM = false; //Use Money Management or not
//extern double  Risk = 10; //percent of available margin to risk.
//extern int     PairsTraded=0; //if set to 0 then std MM.  If set to the number of Pairs traded then the risk is divided amongst the number of pairs.

extern bool    UseClose=true; // This will use the SuperClose().  
extern int     TSactivation=0,TrailPips=50; // TSactivation will set the point where the TS will start. 

extern bool    UseHourTrade = false; // Time filter
extern int     FromHourTrade = 7; // start trading on this hour
extern int     ToHourTrade = 20; // end trading on this hour

extern bool    UseSimpleTF=false;
extern int     period=0; // leave this number as zero to use the period from the chart.
extern bool    OneTradeperPeriod=false;  //This will only allow one new trade per period.
extern bool    Alerts=false,AlertOnlyMode=false;// Alerts will alert when trade signal is present.  AOM will not place trades, but will alert to the platform
extern bool    WeekendMode=false;//True=Will close all trades on and after the hour to close.
extern int     hour_to_close=21;

extern bool    Reverse=false;// reverses orders regardless of ALL signal direction


double      highprofit;
string      xname,start;
int         ID;
int         bar;//tracks the period where a trade was placed. 
double      Hi, Lo, Op;
int         tsTicket[21];
double      tsPrice[21];
bool        tsok[21];
bool        lopen,sopen;
extern int Minutes=5;
extern int MaxPconfirm=3;
int upa,upb,upd,dna,dnb,dnd;
extern int Fast=5,Slow=7;
//////////////////////////new v

//double macb[21]; extern int MacLevel=25, MacDirection=2; extern int Confirm=1;extern bool UseCrossMode=false;int bcnt;

//bool hedged;
//////////////////////////////////////////////////////////////////////////////////////////////
int init(){
    ID=ID_BASE+P(period);
    start=TimeToStr(CurTime(),TIME_DATE|TIME_SECONDS);
    xname=EAname+"_"+DoubleToStr(ID,0);
  //  Comment("\n",xname," started @ ",start,"\n","Floating P&L: ",profit(),"\n",presentpos());
  // for(int i=0;i<=21;i++){
    //  macb[i]=mac(i);
    //  Minutes=0;
  // }
}
//////////////START FUNCTION//////////////////START FUNCTION//////////////////START FUNCTION///////
int start(){

   if( WeekendMode ){
      if( WE() )return(0);
   }   
   if( UseClose ){
      if(orderscnt()>0)SuperClose();
   }
   if( UseHourTrade ){
      if(!(Hour()>=FromHourTrade&&Hour()<=ToHourTrade)){
         return(0);
      }
   }
   runchk();
   if( !OneTradeperPeriod || bar!=iBars(Symbol(),P(period)) ){
//   openorder(1);
      
      CheckOpen();
   }
   
   //Comment("\n",xname," started @ ",start,"\n","Floating P&L: ",profit(),"\n",presentpos());
   //Print(baropen(1)," Percent ",(BarOpenPercent),"  ",baropen(2));
}


/////////////START FUNCTION///////////////////START FUNCTION//////////////////////START FUNCTION/////  
bool a(int t){
Print("MACD()");
   double macd=iMACD(NULL,0,8,12,1,MODE_CLOSE,MODE_MAIN,1);
   double macd2=iMACD(NULL,0,8,12,1,MODE_CLOSE,MODE_MAIN,2);
   if(t==1 && macd>0 && macd2<0){Print("macd true long");return(true);}
   if(t==2 && macd<0 && macd2>0){Print("macd true short");return(true);}
   return(false);
}
bool b(int t){
Print("cci()");
   double cci=iCCI(NULL,0,35,MODE_CLOSE,1);
   double cci2=iCCI(NULL,0,35,MODE_CLOSE,2);
   if(t==1 && cci>0 && cci2<0){Print("true cci long");return(true);}
   if(t==2 && cci<0 && cci2>0){Print("true cci short");return(true);}
   return(false);
}
bool c(int t){
   double PADX=iADX(NULL,Minutes,14 ,PRICE_CLOSE,1,1);
   double NADX=iADX(NULL,Minutes,14 ,PRICE_CLOSE,2,1);
   
   double Psar = iSAR(NULL,Minutes,0.02,0.2,0) ;
   
   if(t==2){
      if (Psar > iClose(NULL, Minutes,0) && NADX > PADX)
         {Print("true flat short");return(true);}
      
   }
   if(t==1){
      if (Psar < iClose(NULL, Minutes,0) && PADX > NADX)    
         {Print("true flat long");return(true);}
      
   }
   return(false);
}
bool d(int t){

   double fast=iMA(NULL,0,Fast,0,MODE_EMA,MODE_CLOSE,1);
   double slow=iMA(NULL,0,Slow,0,MODE_EMA,MODE_CLOSE,1);
   double fast2=iMA(NULL,0,Fast,0,MODE_EMA,MODE_CLOSE,2);
   double slow2=iMA(NULL,0,Slow,0,MODE_EMA,MODE_CLOSE,2);
   
   if(t==1 && fast>slow && fast2<slow2){Print("true cross long"); return(true);}
   if(t==2 && fast<slow && fast2>slow2){Print("true cross short");return(true);}
   return(false);
   
} 
void runchk(){
   if(a(1)) upa=Bars;
   if(a(2)) dna=Bars;
   if(b(1)) upb=Bars;
   if(b(2)) dnb=Bars;
   if(d(1)) upd=Bars;
   if(d(2)) dnd=Bars;
} 
   
int CheckOpen(){ 
 ///////////////////trade criteria here
   int X=MaxPconfirm;
   if(MathAbs(upa-upb)<X && MathAbs(upb-upd)<X && MathAbs(upa-upd)<X && upa!=0&&upb!=0&&upd!=0){
      if(c(1)&& Bars-((upa+upb+upd)/3)<4       ){
         close2(2);
         if(bb(1)==0){
            openorder(1);
         }
      }
   }
   if(MathAbs(dna-dnb)<X && MathAbs(dnb-dnd)<X && MathAbs(dna-dnd)<X && dna!=0&&dnb!=0&&dnd!=0){
      if(c(2)&& Bars-((dna+dnb+dnd)/3)<4){
         close2(1);
         if(bb(2)==0){
            openorder(2);
         }
      }
   }
   return(0); 
}

int bb(int t){
   int bb,ss;
   for(int i =0;i<OrdersTotal();i++){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(OrderSymbol()==Symbol() && ID==OrderMagicNumber()){
            if(OrderType()==OP_BUY)bb++;
            if(OrderType()==OP_SELL)ss++;
         }
      }
   }
   if(t==1)return(bb);
   if(t==2)return(ss);
}
/*
void buffers(){// tracks the indicator values 

   if(Bars>bcnt){
      for(int i=500;i>0;i--){
         macb[i]=macb[i-1];
         //bbuffer[i]=bbuffer[i-1];
      }
      bcnt=Bars;
   }
   macb[0]=mac(0);
   //bbuffer[i]=blue(0);
} */ 
///////////////////////////////////////////////////////////////////////////////////////////////////
/*
double mac(int i){
  return(iMACD(NULL,0,14,26,9,PRICE_CLOSE,MODE_MAIN,i));
  
}
int macdir(){
int dir;
   for(int i=0;i<20;i++){
      if(macb[0]>macb[1]){
         if(macb[i]>macb[i+1])dir++;else break;
      }
      else if(macb[0]<macb[1]){
         if(macb[i]<macb[i+1])dir--;else break;
      }
   }
   return(dir);
}
*/
//////////////////////////////////////////////////////////////////////////////////////////////
void close2(int t){
   for(int i=0;i<OrdersTotal();i++){
      if(OrderSelect(i,SELECT_BY_POS)){
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==ID){
            if(t==1 && OrderType()==OP_BUY){
               CloseOrder(1);
            }
            else if(t==2 && OrderType()==OP_SELL){
               CloseOrder(2);
            }           
         }
      }
   }
}

/////////////////////////////////////////////////////////////////////////////////////////////  

void openorder(int f){
   double sl,tp;int res;
   //string comm="Pro-Gen_"+DoubleToStr(ID,0);
   if(Reverse){
      if(f==1)f=2;
      else if(f==2)f=1;
   }
   if(f==2){
      while(res<=0){
         if(stoploss==0){sl=0;}else{sl=Bid+stoploss*Point;}
         if(takeprofit==0){tp=0;}else{tp=Bid-takeprofit*Point;}
        // if(UseClose)tp=Bid-(takeprofit*2)*Point;
         if(!AlertOnlyMode){
            res=OrderSend(Symbol(),OP_SELL,lots,Bid,2,sl,tp,xname,ID,0,Red); 
            
         }
         if(res<=0){
            int error=GetLastError();
            Print("Error = ",ErrorDescription(error));
            if(error==134)break;
            Sleep(1000);
            RefreshRates();
         }
      }
      if(Alerts || AlertOnlyMode){
         Alert("Short Signal on ",Symbol());
      }   
    //  lopen=false;sopen=false;
      bar=iBars(NULL,P(period));
   }
   else if(f==1){
      while(res<=0){
         if(stoploss==0){sl=0;}else{sl=Ask-stoploss*Point;}
         if(takeprofit==0){tp=0;}else{tp=Ask+takeprofit*Point;}
      //   if(UseClose)tp=Ask+(takeprofit*2)*Point;
         if(!AlertOnlyMode){
            res=OrderSend(Symbol(),OP_BUY,lots,Ask,2,sl,tp,xname,ID,0,Blue);
            
         }
         if(res<=0){
            error=GetLastError();
            Print("Error = ",ErrorDescription(error));
            if(error==134)break;
            Sleep(1000);
            RefreshRates();
            
         }
      }
      if(Alerts || AlertOnlyMode){
         Alert("Long Signal on ",Symbol());
      }   
     // lopen=false;sopen=false;
      bar=iBars(NULL,P(period));
   }
}
//////////////////////////////////////////////////////////////////////////////////////////////           

void CloseOrder(int ord){
   bool res;
   if(Reverse){
      if(ord==1)ord=2;
      else if(ord==2)ord=1;
   }
   if (ord==1){
      while(!res){
         res = OrderClose(OrderTicket(),OrderLots(),Bid,3,White); // close 
         if(!res){
            int error=GetLastError();
            Print("Error = ",ErrorDescription(error));
            if(error!=135)break;
            else if(error==135){
               Sleep(1000);
               RefreshRates();
            }
         }
      }
   }
   if (ord==2) { 
      while(!res){                         // MA BUY signals
         res = OrderClose(OrderTicket(),OrderLots(),Ask,3,White); // close 
         if(!res){
            error=GetLastError();
            Print("Error = ",ErrorDescription(error));
            if(error!=135)break;
            else if(error==135){
               Sleep(1000);
               RefreshRates();
            }    
         }      
      }  
   }    
}        
//////////////////////////////////////////////////////////////////////////////////////////////
int P(int peri){ //added the ability to control PeriodTF for different functions.
   if(!UseSimpleTF) {
      if(peri==0) return(Period()); 
      else return(peri);
   }   
   if(UseSimpleTF) {
      if(peri==0) return(Period());
      if(peri==1) return(1);//M1
      if(peri==2) return(5);//M5
      if(peri==3) return(15);//M15
      if(peri==4) return(30);//M30
      if(peri==5) return(60);//H1
      if(peri==6) return(240);//H4
      if(peri==7) return(1440);//Daily
      if(peri==8) return(10080);//weekly
      if(peri==9) return(43200);//monthly
      return(Period());
   }
}
//////////////////////////////////////////////////////////////////////////////////////////////
int orderscnt(){
   int cnt=0;
   for(int i =0;i<OrdersTotal();i++){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(OrderSymbol()==Symbol() && ID==OrderMagicNumber()){
            cnt++;
         }
      }
   }
   return(cnt);
}
//////////////////////////////////////////////////////////////////////////////////////////////
void CloseAllTrades(){
   Print("CloseAllTrades()");
   for(int i =0;i<OrdersTotal();i++){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(OrderSymbol()==Symbol() && ID==OrderMagicNumber()){
            if(OrderType()==OP_BUY){
               CloseOrder(1);
            }else{
               CloseOrder(2);
            }  
         }  
      }  
   }  
}  
////////////////////////////////////////////////////////////////////////////////////////////// 
/*
double LotSize(){
   double lotMM;
   if(PairsTraded==0){
      lotMM = MathCeil(AccountFreeMargin() * Risk / 10000) / 10;
   } else {
      lotMM = MathCeil(AccountFreeMargin() * Risk / 10000 /PairsTraded) / 10 ;
   }
   if (lotMM < 0.1) lotMM = lots;
   if (lotMM > 1.0) lotMM = MathCeil(lotMM);
   if  (lotMM > 100) lotMM = 100;
   return (lotMM);
} 
 */  
//////////////////////////////////////////////////////////////////////////////////////////////
void SuperClose(){
   for(int i=0;i<OrdersTotal();i++){
      if(OrderSelect(i,SELECT_BY_POS)){
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==ID){//Pulls in order that meets the criteria for processing
            int num=0;int pos=0;
            for(int b=0;b<21;b++){// this (loopB) compares the ticket# of the selected order against the number stored in the ticket array
               if(tsTicket[b]==OrderTicket() ){
                  num++; pos=b;// if ticket numbers match, pos is the position in the array where the trailing data is stored
                  Print("(",pos,") Ticket ",tsTicket[pos]," found.  SL is ",tsPrice[pos]);
                  break;
               }  
            }
            if(num==0){ // if the loopB did not find a matching ticket number it is time to initialize the data
               for(int j=0;j<21;j++){
                  if(tsTicket[j]==0){// this is looking for the earliest instance within the array to store the data
                     pos=j;  
                     break;
                  }
               }
               tsTicket[pos]=OrderTicket();// setting the ticket number
               tsok[pos]=false;// this is to determine when trailing kicks in
               Print("(",pos,") New ticket initialized = ",tsTicket[pos]);
            }
            if (OrderType()==OP_SELL) {
               if (!tsok[pos] && (OrderOpenPrice()-Ask>=TSactivation*Point || TSactivation==0 ) ) {// if the trailing factor is false, but it has hit the activation point continue
                  tsPrice[pos]=Ask+TrailPips*Point;// this is the new trailinf stop price
                  tsok[pos]=true;// it's ok to proceed with trailing stop
                  if(TrailPips>8){// if this distance from the current price to the new stop, then modify the order.
                     ModifyStopLoss(Ask+TrailPips*Point);//modifies order
                  }
               }
               if (tsok[pos] && Ask+TrailPips*Point < tsPrice[pos] ){//if the position is gaining in profit
                  tsPrice[pos]=Ask+TrailPips*Point;
                  if(TrailPips>8){ 
                     ModifyStopLoss(Ask+TrailPips*Point);
                  }
               }
               if (tsok[pos] && Ask >= tsPrice[pos] ){// if the postion hits the stop price
                  CloseOrder(2);
                  Print("Short Order ",tsTicket[pos]," Closed from TS");
               }
            }
            if (OrderType()==OP_BUY) {// reverse of SELL
               if(!tsok[pos] && (Bid-OrderOpenPrice() >= TSactivation*Point  || TSactivation==0 ) ) {
                  tsPrice[pos]=Bid-TrailPips*Point;
                  tsok[pos]=true;
                  if(TrailPips>8){
                     ModifyStopLoss(Bid-TrailPips*Point);
                  }
               }
               if (tsok[pos] && Bid-TrailPips*Point > tsPrice[pos] ){
                  tsPrice[pos]=Bid-TrailPips*Point;
                  if(TrailPips > 8){
                     ModifyStopLoss(Bid-TrailPips*Point);
                  }
               }
               if (tsok[pos] && Bid <= tsPrice[pos] ){
                  CloseOrder(1);
                  Print("Long Order ",tsTicket[pos]," Closed from TS");
   }  }  }  }  }
   for(i=0;i<21;i++){// this searches the array for ticket numbers that are now obsolete due to an order that has closed
      if(tsTicket[i]>0){
         bool found=false;
         for(b=0;b<OrdersTotal();b++){
            OrderSelect(b,SELECT_BY_POS);
            if(tsTicket[i]==OrderTicket()){
               found=true;
             break;
            }
         }
         if(!found){// if there are matching ticket numbers in the trade pool and the array then nothing happens
            tsTicket[i]=0;tsPrice[i]=0;tsok[i]=false;// if there is an obolete ticket the the data is reset.  And the next new ticket data can occupy this space
           // Print("Array pos ",i," Cleaned");
}  }  }  }

//////////////////////////////////////////////////////////////////////////////////////////////
void ModifyStopLoss(double ldStop) {
  bool   fm;
  double ldOpen=OrderOpenPrice();
  double ldTake=OrderTakeProfit();
  fm=OrderModify(OrderTicket(), ldOpen, ldStop, ldTake, 0, Pink);
}


//////////////////////////////////////////////////////////////////////////////////////////////
bool WE(){
   if(orderscnt()>0){
      if(DayOfWeek()>=5 && Hour()>=hour_to_close){
         CloseAllTrades();
         return(true);
      }
   }else{
      if(DayOfWeek()>=5 && Hour()>=hour_to_close -2){
         return(true);
      }
   }
   return(false); 
}
//////////////////////////////////////////////////////////////////////////////////////////////////// 
// Nicholishen nick@barker.net /////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////                                         //
////////////////////////////////////////////////////////////////////////////////////////////////////